/* 
 * File:   Exceptions.h
 * Author: gruen
 *
 * Created on 29. Dezember 2010, 11:24
 */

#ifndef CLAEXCEPTIONS_H
#define	CLAEXCEPTIONS_H

#include <exception>
#include <string>

namespace CommandLineArgumentLib {

class CLAException : public std::exception {
public:

    CLAException(std::string message) : exceptionMessage(message) {
    }
    CLAException(const CLAException& orig){
        if(this == &orig)
            return;
        
        this->exceptionMessage = orig.exceptionMessage;
    }
    virtual ~CLAException() throw (){}

    virtual const char* what() const throw () {
        return exceptionMessage.c_str();
    }
private:
    std::string exceptionMessage;
};
}

#endif	/* CLAEXCEPTIONS_H */

