/* 
 * File:   CommandLineArgumentParser.h
 * Author: gruen
 *
 * Created on 29. Dezember 2010, 09:54
 */

#ifndef COMMANDLINEARGUMENTPARSER_H
#define	COMMANDLINEARGUMENTPARSER_H

#include <list>
#include <string>

#include <CommandLineArgumentManager.h>
#include <CLAExceptions.h>

namespace CommandLineArgumentLib {

class CommandLineArgumentParser {
    typedef std::list<std::string> argumentList;

public:
    CommandLineArgumentParser();
    virtual ~CommandLineArgumentParser();

    void AddHelpFlag(std::string helpFlag);

    void ParseArguments(int argc, char** argv);

    void AddArgumentType(CLArgumentBase *argumentType);

    std::string GetOptionHelpMessage();
    bool IsHelpFlagSet(){
        return helpFlagSet;
    };
private:
    CommandLineArgumentParser(const CommandLineArgumentParser& orig);
    CommandLineArgumentParser& operator=(const CommandLineArgumentParser &orig);

    void ReadArguments(int argc, char** argv);
    bool IsOption(std::string argument);
    void ParseOption();
    std::string GetNextArgument();
    void ParseValue();
    bool ArgumentIsHelpFlag(std::string argument);


    CommandLineArgumentManager argumentManager;

    int argumentCount;
    argumentList arguments;

    int valueIndex;
    argumentList::iterator currentArgumentIterator;

    bool helpFlagSet;
    std::list<std::string> helpFlags;
};
}

#endif	/* COMMANDLINEARGUMENTPARSER_H */

