#include <CLAParseArgumentFunctions.h>

using namespace CommandLineArgumentLib;

bool ParseArgumentFunctions::ParseBool(std::string boolString)
{
    std::stringstream ss(boolString);
    bool b = false;

    if (!(ss >> b).eof())
        throw CLAException("Could not parse bool.");

    return b;
}

std::string ParseArgumentFunctions::ParseString(std::string s)
{
    return s;
}

int ParseArgumentFunctions::ParseNumber(std::string numberString)
{
    std::stringstream ss(numberString);
    int number = 0;

    if (!(ss >> number).eof())
        throw CLAException("Could not parse int.");

    return number;
}

float ParseArgumentFunctions::ParseFloat(std::string floatString){
    std::stringstream ss(floatString);
    float floatValue = 0.0;

    if (!(ss >> floatValue).eof())
        throw CLAException("Could not parse float.");

    return floatValue;
}
