/* 
 * File:   FirstTest.cpp
 * Author: gruen
 *
 * Created on 29.12.2010, 12:45:14
 */

#include <stdlib.h>
#include <iostream>
#include <CommandLineArgumentLib.h>

#include "SingleValueSetting.h"

using namespace CommandLineArgumentLib;

/*
 * Simple C++ Test Suite
 */

void test1() {
    std::cout << "FirstTest test 1" << std::endl;
    int argc = 1;
    char *argv[1];

    argv[0] = "hallo";

    std::cout << "FirstTest test initialised" << std::endl;

    CommandLineArgumentParser parser;

    SingleValueSetting<std::string> stringSetting;
    stringSetting.ParseValue = &ParseString;

    CLARequiredValue value;
    value.SetSetting(&stringSetting);

    parser.AddArgumentType(&value);

    parser.ParseArguments(argc, argv);

    if(stringSetting.GetValue() != "hallo")
        throw "Test 1 failed";
}

void test2() {
    std::cout << "FirstTest test 2" << std::endl;
    std::cout << "%TEST_FAILED% time=0 testname=test2 (FirstTest) message=error message sample" << std::endl;
}

int main(int argc, char** argv) {
    std::cout << "%SUITE_STARTING% FirstTest" << std::endl;
    std::cout << "%SUITE_STARTED%" << std::endl;

    std::cout << "%TEST_STARTED% test1 (FirstTest)" << std::endl;
    test1();
    std::cout << "%TEST_FINISHED% time=0 test1 (FirstTest)" << std::endl;

    std::cout << "%SUITE_FINISHED% time=0" << std::endl;

    return (EXIT_SUCCESS);
}

