/*
 * File:   ParseParameterOption_Test.h
 * Author: gruen
 *
 * Created on 29.12.2010, 16:34:55
 */

#ifndef PARSEPARAMETEROPTION_TEST_H
#define	PARSEPARAMETEROPTION_TEST_H

#include <cppunit/extensions/HelperMacros.h>
#include <CommandLineArgumentLib.h>

class ParseParameterOption_Test : public CPPUNIT_NS::TestFixture {
    CPPUNIT_TEST_SUITE(ParseParameterOption_Test);

    CPPUNIT_TEST(ParseSingleParameterOptionString_Success);
    CPPUNIT_TEST(ParseSingleParameterOptionInt_Success);
    CPPUNIT_TEST(ParseSingleParameterOptionInt_ParameterInvalid);
    CPPUNIT_TEST(ParseSingleParameterOption_NoParameter);
    CPPUNIT_TEST(ParseSingleParameterOption_InvalidOption);

    CPPUNIT_TEST_SUITE_END();

public:
    ParseParameterOption_Test();
    virtual ~ParseParameterOption_Test();
    void setUp();
    void tearDown();

private:
    void ParseSingleParameterOptionString_Success();
    void ParseSingleParameterOptionInt_Success();
    void ParseSingleParameterOptionInt_ParameterInvalid();
    void ParseSingleParameterOption_NoParameter();
    void ParseSingleParameterOption_InvalidOption();

    CommandLineArgumentLib::CommandLineArgumentParser *parser;
};

#endif	/* PARSEPARAMETEROPTION_TEST_H */

