/*
 * File:   ParseValues_Test.h
 * Author: gruen
 *
 * Created on 30.12.2010, 09:53:08
 */

#ifndef PARSEVALUES_TEST_H
#define	PARSEVALUES_TEST_H

#include <cppunit/extensions/HelperMacros.h>
#include <CommandLineArgumentLib.h>

class ParseValues_Test : public CPPUNIT_NS::TestFixture {
    CPPUNIT_TEST_SUITE(ParseValues_Test);

    CPPUNIT_TEST(ParseRequiredValueString_Success);
    CPPUNIT_TEST(ParseRequiredValueInt_Success);
    CPPUNIT_TEST(ParseTwoRequiredValuesStringInt_Success);
    CPPUNIT_TEST(ParseRequiredValueString_ValueMissing);
    CPPUNIT_TEST(ParseRequiredValueInt_ValueInvalid);

    CPPUNIT_TEST_SUITE_END();

public:
    ParseValues_Test();
    virtual ~ParseValues_Test();
    void setUp();
    void tearDown();

private:
    void ParseRequiredValueString_Success();
    void ParseRequiredValueInt_Success();
    void ParseTwoRequiredValuesStringInt_Success();
    void ParseRequiredValueString_ValueMissing();
    void ParseRequiredValueInt_ValueInvalid();

    CommandLineArgumentLib::CommandLineArgumentParser *parser;
};

#endif	/* PARSEVALUES_TEST_H */

