/* 
 * File:   CommandExecutor.h
 * Author: jochen
 *
 * Created on 10. Januar 2011, 15:23
 */

#ifndef COMMANDEXECUTOR_H
#define	COMMANDEXECUTOR_H

#include <string>
#include <SocketConnector.h>
#include <ControlCommunicationBase.h>

class CommandExecutor {
public:
    CommandExecutor();
    virtual ~CommandExecutor();

    void Shutdown();
    void PrintSockets();
    void AddReceiverSocket(std::string senderIp, std::string receiverIp);
    void AddSenderSocket(std::string senderIp, std::string receiverIp);
    void Reroute(int receiverSocketNo, int senderSocketNo);
    void SetReceiverParameter(int socketNo, media_transport_protocol::prrt_param *parameterObject);
    void SetSenderParameter(int socketNo, media_transport_protocol::prrt_param *parameterObject);
    void SetOption(int socketNo, media_transport_protocol::prrt_option *optionObject);
    
    void SetSocketConnector(SocketConnector* socketConnector) {
        this->socketConnector = socketConnector;
    }
    SocketConnector* GetSocketConnector() const {
        return socketConnector;
    }
    void SetControlCommunication(ControlCommunicationBase* controlCommunication)
    {
        this->controlCommunication = controlCommunication;
    }
    ControlCommunicationBase* GetControlCommunication() const
    {
        return controlCommunication;
    }
    
private:
    CommandExecutor(const CommandExecutor& orig);

    SocketConnector *socketConnector;
    ControlCommunicationBase *controlCommunication;
};

typedef void (CommandExecutor::*voidExecutorFunctionVoid)();
typedef void (CommandExecutor::*voidExecutorFunctionIntInt)(int, int);
typedef void (CommandExecutor::*voidExecutorFunctionStrStr)(std::string, std::string);
typedef void (CommandExecutor::*voidExecutorFunctionIntParameter)(int, media_transport_protocol::prrt_param*);
typedef void (CommandExecutor::*voidExecutorFunctionIntOption)(int, media_transport_protocol::prrt_option*);

#endif	/* COMMANDEXECUTOR_H */

