/* 
 * File:   CommandParser.h
 * Author: jochen
 *
 * Created on 10. Januar 2011, 14:19
 */

#ifndef COMMANDPARSER_H
#define	COMMANDPARSER_H

#include <string>
#include <map>
#include <InputCommandBase.h>
#include <ControlCommunicationBase.h>

class CommandParser {
public:
    CommandParser();
    
    virtual ~CommandParser();

    void addCommand(InputCommandBase *command);
    void start();
    std::string GetHelpMessage();
    void SetControlCommunication(ControlCommunicationBase* controlCommunication)
    {
        this->controlCommunication = controlCommunication;
    }
    ControlCommunicationBase* GetControlCommunication() const
    {
        return controlCommunication;
    }
private:
    CommandParser(const CommandParser& orig);

    std::string ReadCommandKey();
    InputCommandBase *FindInputCommand(std::string key);

    std::map<std::string, InputCommandBase*> commandList;

    ControlCommunicationBase *controlCommunication;
};

#endif	/* COMMANDPARSER_H */

