/* 
 * File:   SetAHECCodingParameterCommand.cpp
 * Author: jochen
 * 
 * Created on 27. Januar 2011, 16:29
 */

#include <SetAHECCodingParameterCommand.h>
#include <iostream>

using namespace std;
using namespace media_transport_protocol;

SetAHECCodingParameterCommand::SetAHECCodingParameterCommand() {
}

SetAHECCodingParameterCommand::SetAHECCodingParameterCommand(const SetAHECCodingParameterCommand& orig) {
}

SetAHECCodingParameterCommand::~SetAHECCodingParameterCommand() {
}

void SetAHECCodingParameterCommand::ReadParameters(istream &inputstream) {

    SetParameterCommand<param_AHEC>::ReadParameters(inputstream);

    // TODO check the usage and apply the new parameter param_AHEC.
    int d_target = 0;
    int d_fec = 0;
    int d_c = 0;
    int d_req = 0;
    int d_fb = 0;
    int k = 0;
    std::string ahec = "";
    std::vector<unsigned> v_ahec;
#if 0
    // Debug Function test.
    std::vector<unsigned> v1, v2, v3, v4, v5;
    ahec = "0";

    if (!ParseParityPacketRounds(ahec, v1) ) {
      cerr << "0 fail" << endl;
    }
    ahec = "12";
    if (!ParseParityPacketRounds(ahec, v2) ) {
      cerr << "12 fail" << endl;
    }
    ahec = "0,1,16";
    if (!ParseParityPacketRounds(ahec, v3) ) {
      cerr << "0,1,16 fail" << endl;
    }
    ahec = "0,0,16";
    if (ParseParityPacketRounds(ahec, v4) ) {
      cerr << "0,0,16 fail" << endl;
    }
    ahec = "3,0,16";
    if (ParseParityPacketRounds(ahec, v5) ) {
      cerr << "3,0,16 fail" << endl;
    }
#endif

    if(!(inputstream >> d_target).good()) {
        throw "Parameter value not valid";
    }

    if(!(inputstream >> d_fec).good()) {
        throw "Parameter value not valid";
    }

    if(!(inputstream >> d_c).good()) {
        throw "Parameter value not valid";
    }

    if(!(inputstream >> d_req).good()) {
        throw "Parameter value not valid";
    }

    if(!(inputstream >> d_fb).good()) {
        throw "Parameter value not valid";
    }

    if(!(inputstream >> k).good()) {
        throw "Parameter value not valid";
    }

    if(!(inputstream >> ahec).good()) {
        throw "Parameter value not valid";
    }

    if (d_target <= 0 || d_fec <= 0 || d_req <= 0 || d_fb < 0 || k <= 0 ||
        !ParseParityPacketRounds(ahec, v_ahec) ) {
      cerr << "> SetAHECCodingParameterCommand::ReadParameters() ERROR > d_target=" << d_target <<  " d_fec=" << d_fec << " d_fb=" << d_fb << " k=" << k << " parity=" << ahec << endl;
      throw "Invalid parameter value";
    }

    this->SetParameterObject(new param_AHEC(d_target, d_fec, d_c, d_req, d_fb, k, v_ahec));
}

bool SetAHECCodingParameterCommand::ParseParityPacketRounds(std::string &ahec, std::vector<unsigned> &v_ahec) {
    const char *rr = ahec.c_str();
    stringstream ss;
    unsigned int num = 0;
    
    // Convert string to a unsigned int vector and cut off all unnecessary spaces in the string if the given AHEC is valid.
    unsigned int i = 0;
    while (i < ahec.size())
    {
      if (rr[i] == 44) {
        // The char is a comma.
        if (num != 0 || (num == 0 && v_ahec.size() == 0)) {
          v_ahec.push_back( num );
          if (v_ahec.size() == 1) {
            // The first number.
            ss << num;
          }
          else {
            ss << " " << num;
          }
        }
        else {
          cerr << "> SetAHECCodingParameterCommand::ParseParityPacketRounds() ERROR > The given string of AHEC setting is invalid : " << (int) rr[i] << " in " << i << "-th " << ahec << endl;
          return false;
        }
        num = 0;
      } // if (rr[i] == 44)
      else {
        // The char is not a comma.
        int digit = rr[i] - '0';
        if (-1 < digit && digit < 10 ) {
          // The char is a digit.
          num = num * 10 + digit;
        } // if-else : The char is a digit.
        else {
          cerr << "> SetAHECCodingParameterCommand::ParseParityPacketRounds() ERROR > The given string of AHEC setting is invalid : " << (int) rr[i] << " in " << i << "-th " << ahec << endl;
          return false;
        }
      } // if-else : the char is not a comma.
      
      i++;
    } // while (i < ahec.size())
    
    // Handle the last number.
    if (i == ahec.size() && num != 0) {
      v_ahec.push_back( num );
      if (v_ahec.size() == 1) {
        // The first number.
        ss << num;
      }
      else {
        ss << " " << num;
      }
    }
    
    return true;
}
