/* 
 * File:   SetOptionCommand.h
 * Author: jochen
 *
 * Created on 16. Februar 2011, 11:38
 */

#ifndef SETOPTIONCOMMAND_H
#define	SETOPTIONCOMMAND_H

#include <InputCommandBase.h>

template <class TOption>
class SetOptionCommand : public InputCommandBase {
public:

    SetOptionCommand() {
    };

    virtual ~SetOptionCommand() {
        if (this->optionObject != 0)
            delete this->optionObject;
    }

    virtual void ReadParameters(std::istream& inputstream) {

        int value = -1;

        if (!(inputstream >> this->socketno).good()) {
            throw "Socket no not valid";
        }

        if (!(inputstream >> value).good() && value != 0 && value != 1) {
            throw "Option value not valid";
        }

        std::cout << "Setting option to " << value << std::endl;

        this->SetOptionObject(new TOption((typename TOption::option_value)(value)));

    }

    virtual void Execute() {
        CommandExecutor *commandExecutor = GetCommandExecutor();

        (commandExecutor->*ExecuteFunction)(this->socketno, this->optionObject);
    }

    TOption* GetParameterObject() const {
        return optionObject;
    }

    voidExecutorFunctionIntOption ExecuteFunction;

protected:

    void SetOptionObject(TOption* optionObject) {
        if (this->optionObject != 0)
            delete this->optionObject;
        this->optionObject = optionObject;
    }

private:

    SetOptionCommand(const SetOptionCommand& orig) {
    };

    int socketno;
    TOption *optionObject;
};

#endif	/* SETOPTIONCOMMAND_H */

