/* 
 * File:   ConsoleControlCommunication.h
 * Author: gruen
 *
 * Created on 3. Februar 2011, 10:18
 */

#ifndef CONSOLECONTROLCOMMUNICATION_H
#define	CONSOLECONTROLCOMMUNICATION_H

#include <ControlCommunicationBase.h>

class ConsoleControlCommunication : public ControlCommunicationBase {
public:
    ConsoleControlCommunication();
    virtual ~ConsoleControlCommunication();

    virtual void FillInputStream() {};

    virtual std::ostream& GetOutputStream(bool error=false) {
        if(error)
            return std::cerr;
        
        return std::cout;
    }

    virtual std::istream& GetInputStream() {
        return std::cin;
    }

    virtual void FlushOutputStream() {
        std::cout.flush();
    }

private:
    ConsoleControlCommunication(const ConsoleControlCommunication& orig);
};

#endif	/* CONSOLECONTROLCOMMUNICATION_H */

