/* 
 * File:   UnixSocketControlCommunication.h
 * Author: gruen
 *
 * Created on 3. Februar 2011, 10:24
 */

#ifndef UNIXSOCKETCONTROLCOMMUNICATION_H
#define	UNIXSOCKETCONTROLCOMMUNICATION_H

#include <ControlCommunicationBase.h>

#include <sstream>
#include <list>
#include <sys/socket.h>
#include <sys/un.h>

class UnixSocketControlCommunication : public ControlCommunicationBase
{
public:
    UnixSocketControlCommunication();
    virtual ~UnixSocketControlCommunication();

    void CreateUnixSocket(std::string filePath);

    virtual void FillInputStream();

    virtual std::ostream& GetOutputStream(bool error=false)
    {
        if(error)
            commandOutput << "ERROR" << std::endl;
        else
            commandOutput << "SUCCESS" << std::endl;

        return commandOutput;
    }

    virtual std::istream& GetInputStream()
    {
        return commandInput;
    }

    virtual void FlushOutputStream();
    
    void BindUnixSocket();
    void ClearConnection(bool closeConnection=true);

private:
    UnixSocketControlCommunication(const UnixSocketControlCommunication& orig);

    void AcceptConnectionRequest();

    std::stringstream commandInput;
    std::stringstream commandOutput;

    struct sockaddr_un sockaddr;
    int sockaddrLength;
    int localSocketFd;
    int remoteSocketFd;
};

#endif	/* UNIXSOCKETCONTROLCOMMUNICATION_H */

