/* 
 * File:   SocketConnector.h
 * Author: jochen
 *
 * Created on 11. Januar 2011, 16:13
 */

#ifndef SOCKETCONNECTOR_H
#define	SOCKETCONNECTOR_H

#include <SocketList.h>
#include <prrt/prrt_relay.h>
#include <string>
#include <ReceiveSettings.h>
#include <RelaySettings.h>
#include <SendSettings.h>
#include <SocketInitialiser.h>
#include <ControlCommunicationBase.h>

class SocketConnector {
public:
    SocketConnector();
    virtual ~SocketConnector();

    void PrintSockets();
    void AddReceivingSocket(media_transport_protocol::prrt_socket *socket);
    void AddSendingSocket(media_transport_protocol::prrt_socket *socket);
    void AddReceivingSocket(std::string senderIp, std::string receiverIp);
    void AddSendingSocket(std::string senderIp, std::string receiverIp);
    void ConnectSockets(int receiverSocketNo, int senderSocketNo);

    void Shutdown();

    void SetRelay(media_transport_protocol::prrt_relay* relay) {
        this->relay = relay;
    }
    media_transport_protocol::prrt_relay* GetRelay() const {
        return relay;
    }
    void SetReceiverSettings(ReceiveSettings* receiverSettings) {
        this->receiverSettings = receiverSettings;
    }
    ReceiveSettings* GetReceiverSettings() const {
        return receiverSettings;
    }
    void SetSenderSettings(SendSettings* senderSettings) {
        this->senderSettings = senderSettings;
    }
    SendSettings* GetSenderSettings() const {
        return senderSettings;
    }
    SocketList* GetSenderSocketList() {
        return &senderSocketList;
    }
    SocketList* GetReceiverSocketList() {
        return &receiverSocketList;
    }
    void SetRelaySettings(RelaySettings* relaySettings) {
        this->relaySettings = relaySettings;
    }
    RelaySettings* GetRelaySettings() const {
        return relaySettings;
    }
    void SetControlCommunication(ControlCommunicationBase* controlCommunication)
    {
        this->controlCommunication = controlCommunication;
    }
    ControlCommunicationBase* GetControlCommunication() const
    {
        return controlCommunication;
    }
private:
    SocketConnector(const SocketConnector& orig);

    SocketList receiverSocketList;
    SocketList senderSocketList;
    media_transport_protocol::prrt_relay *relay;
    ReceiveSettings *receiverSettings;
    SendSettings *senderSettings;
    RelaySettings *relaySettings;
    ControlCommunicationBase *controlCommunication;

};

#endif	/* SOCKETCONNECTOR_H */

