/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#ifndef AHECPARAMS__
#define AHECPARAMS__


//importing parameters
struct ahecparams {
	unsigned int k;
	unsigned int dmin;
	unsigned int np;
	char* nrt;
	unsigned int ahec;
	unsigned int fec;
	unsigned int dtarget;
	unsigned int rtt;
	float plrtarget;
	unsigned int qholdbacktime;
	unsigned int qholdbackmin;
	unsigned int resendinterval;
	bool fixedK;
	unsigned int TR;
};


// DEFAULT VALUES for parameters

#define DEFAULT_NRT "1113"
#define DEFAULT_TR 15 // wrt. DEFAULT_NRT -> 4 positions!!!

const unsigned int DEFAULT_K = 10;
const unsigned int DEFAULT_NP = 1;
const unsigned int DEFAULT_DMIN = 10;
const unsigned int DEFAULT_AHEC = 1;
const unsigned int DEFAULT_FEC = 0;
const unsigned int DEFAULT_DTARGET = 100;
const unsigned int DEFAULT_RTT = 20;
const unsigned int DEFAULT_QHOLDBACKTIME = 300000;
const unsigned int DEFAULT_QHOLDBACKMIN = 18000;
const unsigned int DEFAULT_RESENDINTERVAL = 10;
const float DEFAULT_PLRTARGET =  0.000001;
const unsigned int DEFAULT_FIXEDK = 1;

//MISC
const char numset[] = "1234567890";

//int dummy();

#endif

