/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#include "prrt_option.h"

using namespace media_transport_protocol;

option_FEEDBACK::option_FEEDBACK(enum option_FEEDBACK::option_value val) {
	option = "feedback";
	value = 0;
	if(val == ON)
		value = 1;
}

option_REPLACE::option_REPLACE(enum option_REPLACE::option_value val) {
	option = "replace";
	value = 0;
	if(val == ON)
		value = 1;
}

option_CODING::option_CODING(enum option_CODING::option_value val) {
	option = "coding";
	value = 0;
	if(val == ON)
		value = 1;
}

option_TIMEOUT::option_TIMEOUT(enum option_TIMEOUT::option_value val){
    option = "timeout";
    value = (int)val;
}

option_RCVBUF::option_RCVBUF(enum option_RCVBUF::Type type, int size){
    switch (type)
    {
      case PRRT_RECV : option = "prrt_rcvbuf"; break;
      case KERNEL_RECV : option = "kernel_rcvbuf"; break;
      case USER_RECV : option = "user_rcvbuf"; break;
      default : option = "prrt_rcvbuf"; break;
    }
    value = size;
}

option_ADAPTATION::option_ADAPTATION(enum option_ADAPTATION::Type type, int interval){
    switch (type)
    {
      case SIMPLE : option = "simple"; break;
      default : option = "simple"; break;
    }
    value = interval;
}

option_BWEST::option_BWEST(enum option_BWEST::Type type, int interval){
    switch (type)
    {
      case TFRC : option = "bwest_tfrc"; break;
      case RTT : option = "bwest_rtt"; break;
      default : option = "bwest_rtt"; break;
    }

    value = interval;
}

option_TRAFFICSHAPING::option_TRAFFICSHAPING(const int datarate){
    option = "trafficshaping";

    value = datarate;
}

option_FBSUPP::option_FBSUPP(enum option_FBSUPP::Option opt, int delay){
    switch (opt)
    {
      case ON : option = "fb_supp_on"; break;
      case OFF : option = "fb_supp_off"; break;
      default : option = "fb_supp_off"; break;
    }
    value = delay;
}
