/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#ifndef PRRT_PARAMS_BASE_H
#define PRRT_PARAMS_BASE_H

#include <sstream>
#include "error.h"

namespace media_transport_protocol {

class prrt_param {
public:
	class param_error : public prrt_error {};
	class value_error : public param_error
		{ public: value_error(const char* reason) {this->reason = reason;}; };

	/// This functions returns the name of the proc file that is responsible for the
	/// parameter.
	virtual std::string get_file_name() const = 0;

	/// Return the value of the parameter as a string.
	virtual std::string get_strvalue() const = 0;
};

}

#endif /*PRRT_PARAMS_BASE_H*/
