/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#ifndef UDP_WRAPPER_H
#define UDP_WRAPPER_H

#include <unistd.h>
#include <sys/socket.h>

//namespace media_transport_protocol {
namespace udp_wrapper {

	int udp_bind(int sockfd, const struct sockaddr *my_addr, socklen_t addrlen)
	{
		return bind(sockfd, my_addr, addrlen);
	}

	int udp_connect(int sockfd, const struct sockaddr *serv_addr, socklen_t addrlen)
	{
		return connect(sockfd, serv_addr, addrlen);
	}

	ssize_t udp_sendto(int s, const void *buf, size_t len, int flags, const struct sockaddr *to, socklen_t tolen)
	{
		return sendto(s, buf, len, flags, to, tolen);
	}

	ssize_t udp_recvfrom(int s, void *buf, size_t len, int flags, struct sockaddr *from, socklen_t *fromlen)
	{
		return recvfrom(s, buf, len, flags, from, fromlen);
	}

	int udp_close(int fd)
	{
		return close(fd);
	}
}
//}

#endif /*PRRT_SOCKETS_H*/

