/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#ifndef _KERNEL_WRAPPERS_H
#define	_KERNEL_WRAPPERS_H

#include "defines.h"
#include <linux/net.h>
#include <linux/in.h>
#include <linux/syscalls.h>
#include <linux/types.h>
#include <linux/inet.h>
#include "prrt_fbpacket.h"

/**
 * Function that wraps the socket send function of the kernel.
 */
extern int wrap_kernel_sendmsg(struct socket *sock, struct sockaddr_in *peer, void *data, size_t data_len);

/**
 * Function that wraps the socket receive function of the kernel.
 */
extern int wrap_kernel_recvmsg(struct socket *sock, void *packet_data, size_t data_len);

#endif	/* _KERNEL_WRAPPERS_H */

