/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#ifndef KUI_PARAM_H
#define KUI_PARAM_H

#include "../defines.h"

/**
 * Type for the different parameters that can be set for the protocol.
 * This type needs to be the same in the module and the lib.
	 */
	enum Param_t {
		/*These are parameters for code estimation*/
		PLR,		/**<Packet loss rate.*/

		/*These are coding parameters, included for testing purposes*/
    AHEC,       ///< Combine coding parameters and retransmission round as well as D_FEC.

    /*These are feedback control parameters, e.g. for congestion control and flow control.*/
		BWEST,		/**Estimated available bandwidth*/
		BUFFB		/**Buffer information from reciever application.*/
	};

	#define NUMBER_CODINGPARAS	4	/**< The number of parameters that must be given to the file for
							the coding parameters.*/

	void *kui_create_param_file(Socketno_t socketno, enum Param_t param);

	void kui_delete_param_file(Socketno_t socketno, enum Param_t param);

	#endif /*KUI_PARAM_H*/

