/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#ifndef SOCKET_MANAGER_H
#define SOCKET_MANAGER_H

#include <linux/list.h>
#include <linux/slab.h>
#include "../prrt_socket.h"
#include "../defines.h"

void sm_init(void);

void sm_uninit(void);

Socketno_t sm_register_socket(int flags, struct prrt_socket* msock, int kui_port);

int sm_unregister_socket(Socketno_t socketno);

int sm_set_socket_privdata(Socketno_t socketno, void **priv_datas, int len);

int sm_socket_list_empty(void);

Socketno_t sm_get_socketno(void);

int sm_get_prrt_sock(Socketno_t socketno, struct prrt_socket **msock);

#endif	/*SOCKET_MANAGER_H*/

