/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#include <stdio.h>
#include <string.h>

int proc_write(const char* filepath, char *command, int clen)
{
	FILE *file = 0;
	int ret = 0;

	/*write create command to register file*/
	file = fopen(filepath, "w");
	if(!file)
		return -1;
	//ret = fwrite(command, sizeof(*command), clen, file);
	ret = fputs(command, file);
	printf("written: %d\n", ret);
	if(ret == EOF)
		ret = -1;
	fclose(file);

	return ret;
}

int proc_read(const char* filepath, char *feedback, int flen)
{
	FILE *file = 0;
	int ret = 0;
	int read = 0;

	/*read feedback from register_file*/
	file = fopen(filepath, "r");
	if(!file)
		return -1;
	while(!feof(file) && read < flen) {
		read += fread(feedback+read, sizeof(*feedback), flen-read,
				file);
	}

	if(!feof(file)) {
		ret = -1;	/*ERROR buffer to small, should not happen*/
	} else {
		//sscanff(rbuf, "%d", &ret);
		feedback[read] = '\0';
		ret = read;
	}

	fclose(file);

	return ret;
}

