/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#ifndef SOCKET_LIST_H
#define SOCKET_LIST_H

struct socket_list {
	struct socket_list *next, *prev;
	int socketno;
};

/**
 * Add a socket to the socketlist.
 * \param sockfd the number of the socket to add.
 * \return 0 on success, -1 if an error occurs
 */
int socket_list_add(int sockfd);

/**
 * Remove a random socket from the list.
 * \return the number of the socket that was deleted, -1 if empty list.
 */
int socket_list_del_rnd();

/**
 * Remove a socket from the list.
 * \param sockfd the number of the socket to remove.
 * \return 1 on success, 0 if not found, -1 if empty list.
 */
int socket_list_del(int sockfd);

/**
 * Is the socket list empty.
 * \return 1 if empty, 0 if not empty
 */
inline int socket_list_empty();

#endif /*SOCKET_LIST_H*/
