/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "prrt_sockets.h"
#include "socket_list.h"

#define BUFFERSIZE 50

int main(int argc, char *argv[])
{
	int RTT = 300; /*in ms*/

	if(argc < 2) {
		printf("Need port for command line argument 1!\n");
		return 1;
	}

	prrt_init();

	int sockfd1 = 0;
	int sockfd2 = 0;
	char *addr = "127.0.0.1";
	unsigned short port = atoi(argv[1]);
	char *Message = "Hallo Welt!";
	char buffer[BUFFERSIZE];
	int i = 0;
	int bytes_sent = 0;
	int testpara = 5;

	printf("Creating socket 1!\n");
	sockfd1 = prrt_socket();
	printf("%d\n", sockfd1);

	printf("Creating socket 2!\n");
	sockfd2 = prrt_socket();
	printf("%d\n", sockfd2);

	printf("Binding socket 1 to %s:%d!\n", addr, port);
	if(prrt_bind(sockfd1, addr, port, addr) < 0)
		printf("Error!\n");

	printf("Connecting socket 2 to %s:%d!\n", addr, port);
	if(prrt_connect(sockfd2, addr, port, addr) < 0)
		printf("Error!\n");

	printf("Sending message of len %d: %s\n", strlen(Message), Message);
	for(i=1; i<5; i++) {
		sprintf(buffer, "%s %d", Message, i);
		bytes_sent = prrt_send(sockfd2, buffer, strlen(buffer), 0);
		if(bytes_sent < 0)
			printf("Error on send!\n");

		printf("bytes_sent: %d\n", bytes_sent);
	}

	sleep(3);

	for(i=5; i<50; i++) {
		sprintf(buffer, "%s %d", Message, i);
		bytes_sent = prrt_send(sockfd2, buffer, strlen(buffer), 0);
		if(bytes_sent < 0)
			printf("Error on send!\n");

		printf("bytes_sent: %d\n", bytes_sent);
	}
	
	while ((i = prrt_recv(sockfd1, buffer, BUFFERSIZE, 0)) > 0) {
		printf("Received message: %s\n", buffer);
	}
	if(i < 0)
		printf("Error on receive!\n");

	printf("Deleting sockets!\n");

	prrt_uninit();
	return 0;
}
